package com.bergerkiller.bukkit.nolagg.chunks;

import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import com.bergerkiller.bukkit.common.MessageBuilder;
import com.bergerkiller.bukkit.common.permissions.NoPermissionException;
import com.bergerkiller.bukkit.common.utils.CommonUtil;
import com.bergerkiller.bukkit.common.utils.MathUtil;
import com.bergerkiller.bukkit.nolagg.base.CommandHandler;

public class Commands extends CommandHandler {

	@Override
	public boolean handle(CommandSender sender, String[] args) throws NoPermissionException {
		if (args.length == 0) return false;
		if (args[0].equalsIgnoreCase("sending")) {
			double avgrate = MathUtil.round(ChunkSendQueue.getAverageRate(), 2);
			double compbus = MathUtil.round(ChunkSendQueue.compressBusyPercentage, 2);
			if (sender instanceof Player) {
				this.permission(sender, "nolagg.chunks.sending");
				
				//show sending information of the player
				ChunkSendQueue queue = ChunkSendQueue.bind((Player) sender);
				if (queue != null) {
					MessageBuilder msg = new MessageBuilder();
					msg.green("You receive ").yellow(MathUtil.round(queue.getRate(), 2));
					msg.green(" chunks each tick (");
					msg.yellow(avgrate).yellow(" avg").green(")").newLine();
				    msg.green("You have received ");
				    int sent = CommonUtil.chunkArea - queue.getPendingSize();
				    double per = MathUtil.round((double) sent / (double) CommonUtil.chunkArea * 100.0, 2);
				    msg.yellow(sent).white("/").yellow(CommonUtil.chunkArea).green(" chunks (");
				    msg.yellow(per, "%").green(")").newLine();
				    msg.green("Your packet buffer is ").green(queue.getBufferLoadMsg()).green(" used");
				    msg.newLine().green("Chunk compression is ");
				    if (compbus > 70) {
				    	msg.red(compbus, "%");
				    } else if (compbus > 40) {
				    	msg.yellow(compbus, "%");
				    } else {
				    	msg.green(compbus, "%");
				    }
				    msg.green(" of the time busy");
				    
					msg.send(sender);
				} else {
					sender.sendMessage("An unknown error occured!");
				}
			} else {
				//show average sending info
				sender.sendMessage("Average chunk sending rate: " + avgrate + " chunks each tick");
				sender.sendMessage("Chunk compression is " + compbus + "% of the time busy");
			}
			return true;
		}
		return false;
	}

}
